import { Collection, Db, MongoClient, MongoClientOptions } from 'mongodb';
import { Connection, ConnectionConfig, QueryResult } from './Connection';
import { QueryOrder } from '../query';
import { FilterQuery } from '..';
export declare class MongoConnection extends Connection {
    protected client: MongoClient;
    protected db: Db;
    connect(): Promise<void>;
    close(force?: boolean): Promise<void>;
    isConnected(): Promise<boolean>;
    getCollection(name: string): Collection;
    getDefaultClientUrl(): string;
    getConnectionOptions(): MongoClientOptions & ConnectionConfig;
    getClientUrl(): string;
    execute(query: string): Promise<any>;
    find<T>(collection: string, where: FilterQuery<T>, orderBy?: Record<string, QueryOrder>, limit?: number, offset?: number): Promise<T[]>;
    insertOne<T>(collection: string, data: Partial<T>): Promise<QueryResult>;
    updateMany<T>(collection: string, where: FilterQuery<T>, data: Partial<T>): Promise<QueryResult>;
    deleteMany<T>(collection: string, where: FilterQuery<T>): Promise<QueryResult>;
    aggregate(collection: string, pipeline: any[]): Promise<any[]>;
    countDocuments<T>(collection: string, where: FilterQuery<T>): Promise<number>;
    private convertObjectIds;
    private transformResult;
}
