import { NamingStrategy } from '../naming-strategy';
import { IPrimaryKey } from '../decorators';
import { SchemaHelper } from '../schema';
export declare abstract class Platform {
    protected abstract schemaHelper: SchemaHelper;
    usesPivotTable(): boolean;
    supportsTransactions(): boolean;
    supportsSavePoints(): boolean;
    getNamingStrategy(): {
        new (): NamingStrategy;
    };
    getParameterPlaceholder(index?: number): string;
    usesReturningStatement(): boolean;
    usesCascadeStatement(): boolean;
    getSchemaHelper(): SchemaHelper;
    requiresNullableForAlteringColumn(): boolean;
    /**
     * Normalizes primary key wrapper to scalar value (e.g. mongodb's ObjectID to string)
     */
    normalizePrimaryKey<T = number | string>(data: IPrimaryKey): T;
    /**
     * Converts scalar primary key representation to native driver wrapper (e.g. string to mongodb's ObjectID)
     */
    denormalizePrimaryKey(data: IPrimaryKey): IPrimaryKey;
    /**
     * Used when serializing via toObject and toJSON methods, allows to use different PK field name (like `id` instead of `_id`)
     */
    getSerializedPrimaryKeyField(field: string): string;
}
