"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const naming_strategy_1 = require("../naming-strategy");
class Platform {
    usesPivotTable() {
        return true;
    }
    supportsTransactions() {
        return true;
    }
    supportsSavePoints() {
        return false;
    }
    getNamingStrategy() {
        return naming_strategy_1.UnderscoreNamingStrategy;
    }
    getParameterPlaceholder(index) {
        return '?';
    }
    usesReturningStatement() {
        return false;
    }
    usesCascadeStatement() {
        return false;
    }
    getSchemaHelper() {
        return this.schemaHelper;
    }
    requiresNullableForAlteringColumn() {
        return false;
    }
    /**
     * Normalizes primary key wrapper to scalar value (e.g. mongodb's ObjectID to string)
     */
    normalizePrimaryKey(data) {
        return data;
    }
    /**
     * Converts scalar primary key representation to native driver wrapper (e.g. string to mongodb's ObjectID)
     */
    denormalizePrimaryKey(data) {
        return data;
    }
    /**
     * Used when serializing via toObject and toJSON methods, allows to use different PK field name (like `id` instead of `_id`)
     */
    getSerializedPrimaryKeyField(field) {
        return field;
    }
}
exports.Platform = Platform;
