"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const async_hooks_1 = require("async_hooks");
const uuid_1 = require("uuid");
class RequestContext {
    constructor(em) {
        this.em = em;
        this.id = uuid_1.v4();
    }
    static create(em, next) {
        RequestContext.CONTEXT[async_hooks_1.executionAsyncId()] = new RequestContext(em.fork());
        const init = (asyncId, type, triggerId) => {
            if (RequestContext.CONTEXT[triggerId]) {
                RequestContext.CONTEXT[asyncId] = RequestContext.CONTEXT[triggerId];
            }
        };
        const destroy = (asyncId) => {
            delete RequestContext.CONTEXT[asyncId];
        };
        async_hooks_1.createHook({ init, destroy }).enable();
        next();
    }
    static currentRequestContext() {
        return RequestContext.CONTEXT[async_hooks_1.executionAsyncId()] || null;
    }
    static getEntityManager() {
        const context = RequestContext.currentRequestContext();
        return context ? context.em : null;
    }
}
RequestContext.CONTEXT = {};
exports.RequestContext = RequestContext;
